if (!("finalizeConstruction" in ViewPU.prototype)) {
    Reflect.set(ViewPU.prototype, "finalizeConstruction", () => { });
}
interface BackgroundLocationPage_Params {
    message?: string;
    locationResultString?: string;
    locationManager_01?: TencentLocationManager;
    locationManager_02?: TencentLocationManager;
    locationManager_03?: TencentLocationManager;
    context?;
}
import { TencentLocationConstant, TencentLocationManager, TencentLocationRequest } from "@package:pkg_modules/.ohpm/TencentLocationSDK@t7utmt6zbidmbd+rcrnd4pbf1yjg6gzq6rfynyunhja=/pkg_modules/TencentLocationSDK/Index";
import { displayStringForShortTime, displayStringForTencentLocation } from "@bundle:com.tencent.TencentLocationSDKDemo_HarmonyOS/entry/ets/utils/TencentUtils";
import type ApplicationStateChangeCallback from "@ohos:app.ability.ApplicationStateChangeCallback";
import type common from "@ohos:app.ability.common";
const TAG = '[BackgroundLocationPage]';
class BackgroundLocationPage extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.__message = new ObservedPropertySimplePU('后台定位', this, "message");
        this.__locationResultString = new ObservedPropertySimplePU('', this, "locationResultString");
        this.locationManager_01 = TencentLocationManager.getInstance();
        this.locationManager_02 = TencentLocationManager.getInstance();
        this.locationManager_03 = TencentLocationManager.getInstance();
        this.context = getContext(this) as common.UIAbilityContext;
        this.setInitiallyProvidedValue(params);
        this.finalizeConstruction();
    }
    setInitiallyProvidedValue(params: BackgroundLocationPage_Params) {
        if (params.message !== undefined) {
            this.message = params.message;
        }
        if (params.locationResultString !== undefined) {
            this.locationResultString = params.locationResultString;
        }
        if (params.locationManager_01 !== undefined) {
            this.locationManager_01 = params.locationManager_01;
        }
        if (params.locationManager_02 !== undefined) {
            this.locationManager_02 = params.locationManager_02;
        }
        if (params.locationManager_03 !== undefined) {
            this.locationManager_03 = params.locationManager_03;
        }
        if (params.context !== undefined) {
            this.context = params.context;
        }
    }
    updateStateVars(params: BackgroundLocationPage_Params) {
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__message.purgeDependencyOnElmtId(rmElmtId);
        this.__locationResultString.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__message.aboutToBeDeleted();
        this.__locationResultString.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private __message: ObservedPropertySimplePU<string>;
    get message() {
        return this.__message.get();
    }
    set message(newValue: string) {
        this.__message.set(newValue);
    }
    private __locationResultString: ObservedPropertySimplePU<string>;
    get locationResultString() {
        return this.__locationResultString.get();
    }
    set locationResultString(newValue: string) {
        this.__locationResultString.set(newValue);
    }
    private locationManager_01?: TencentLocationManager;
    private locationManager_02?: TencentLocationManager;
    private locationManager_03?: TencentLocationManager;
    private context;
    aboutToAppear(): void {
        // 手动方式 1: 进入后台的回调中开启后台定位任务, 进入前台的回调中停止后台定位任务
        // this.registerApplicationStateChangeNotification()
    }
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            RelativeContainer.create();
        }, RelativeContainer);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Column.create({ space: 30 });
            Column.height('100%');
            Column.width('100%');
        }, Column);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Text.create(this.message);
            Text.fontSize(50);
            Text.fontWeight(FontWeight.Bold);
        }, Text);
        Text.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create({ space: 30 });
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel('开始连续定位_01(后台)');
            Button.onClick(() => {
                this.startContinuousLocation_01();
            });
        }, Button);
        Button.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel('停止连续定位_01');
            Button.onClick(() => {
                this.stopContinuousLocation_01();
            });
        }, Button);
        Button.pop();
        Row.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create({ space: 30 });
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel('开始连续定位_02(后台)');
            Button.onClick(() => {
                this.startContinuousLocation_02();
            });
        }, Button);
        Button.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel('停止连续定位_02');
            Button.onClick(() => {
                this.stopContinuousLocation_02();
            });
        }, Button);
        Button.pop();
        Row.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create({ space: 30 });
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel('开始连续定位_03(非后台)');
            Button.onClick(() => {
                this.startContinuousLocation_03();
            });
        }, Button);
        Button.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel('停止连续定位_03');
            Button.onClick(() => {
                this.stopContinuousLocation_03();
            });
        }, Button);
        Button.pop();
        Row.pop();
        Column.pop();
        RelativeContainer.pop();
    }
    registerApplicationStateChangeNotification() {
        const that = this;
        const callback: ApplicationStateChangeCallback = {
            onApplicationBackground() {
                console.warn(TAG, 'app 进入后台');
                that.locationManager_01?.startBackgroundLocationTask(); // 停止后台定位
            },
            onApplicationForeground() {
                console.warn(TAG, 'app 进入前台');
                that.locationManager_01?.stopBackgroundLocationTask(); // 开启后台定位
            }
        };
        this.context.getApplicationContext().on('applicationStateChange', callback);
    }
    startContinuousLocation_01() {
        // 手动方式 2.1: 在自己封装的开始定位的方法中开启后台定位任务
        this.locationManager_01?.startBackgroundLocationTask();
        const request: TencentLocationRequest = TencentLocationRequest.default().setRequestLevel(TencentLocationConstant.RequestLevel.POI).setReverseGeocodeRequestInterval(1);
        this.locationManager_01?.startContinuousLocation(request, tencentLocation => {
            const displayString = `${displayStringForShortTime(new Date().getTime())},${request.displayStringForContinuousLocation()},${displayStringForTencentLocation(tencentLocation)}` + '\n----------\n';
            this.locationResultString += displayString;
            console.log(TAG, `连续定位成功_01, ${displayString}`);
        }, error => {
            const errorString = `error: ${error.code},${error.name},${error.message}` + '\n----------\n';
            this.locationResultString += errorString;
            console.error(TAG, `连续定位失败_01, ${errorString}`);
        });
    }
    stopContinuousLocation_01() {
        // 手动方式 2.2: 在自己封装的停止定位的方法中关闭后台定位任务
        this.locationManager_01?.stopBackgroundLocationTask();
        this.locationManager_01?.stopContinuousLocation();
    }
    startContinuousLocation_02() {
        // 配置方式: 在 request 中设置后台定位任务, sdk 会在开始和结束定位的时候开启后台定位任务和关闭后台定位任务, 类似 "手动方式 2"
        const request: TencentLocationRequest = TencentLocationRequest.default().setRequestLevel(TencentLocationConstant.RequestLevel.POI).setReverseGeocodeRequestInterval(1).setEnableBackgroundLocation(true);
        this.locationManager_02?.startContinuousLocation(request, tencentLocation => {
            const displayString = `${displayStringForShortTime(new Date().getTime())},${request.displayStringForContinuousLocation()},${displayStringForTencentLocation(tencentLocation)}` + '\n----------\n';
            this.locationResultString += displayString;
            console.log(TAG, `连续定位成功_02, ${displayString}`);
        }, error => {
            const errorString = `error: ${error.code},${error.name},${error.message}` + '\n----------\n';
            this.locationResultString += errorString;
            console.error(TAG, `连续定位失败_02, ${errorString}`);
        });
    }
    stopContinuousLocation_02() {
        this.locationManager_02?.stopContinuousLocation();
    }
    startContinuousLocation_03() {
        // 后台定位是全局的, 一个 UIAbility 中只会存在一个后台定位任务, 如果一个 UIAbility 中开启了后台定位任务, 其他 UIAbility 中就不能再开启后台定位任务
        // locationManager_02 开启后台定位任务后, locationManager_03 正常开启连续定位就可以后台定位
        const request: TencentLocationRequest = TencentLocationRequest.default().setRequestLevel(TencentLocationConstant.RequestLevel.POI).setReverseGeocodeRequestInterval(1);
        this.locationManager_03?.startContinuousLocation(request, tencentLocation => {
            const displayString = `${displayStringForShortTime(new Date().getTime())},${request.displayStringForContinuousLocation()},${displayStringForTencentLocation(tencentLocation)}` + '\n----------\n';
            this.locationResultString += displayString;
            console.warn(TAG, `连续定位成功_03, ${displayString}`);
        }, error => {
            const errorString = `error: ${error.code},${error.name},${error.message}` + '\n----------\n';
            this.locationResultString += errorString;
            console.error(TAG, `连续定位失败_03, ${errorString}`);
        });
    }
    stopContinuousLocation_03() {
        this.locationManager_03?.stopContinuousLocation();
    }
    rerender() {
        this.updateDirtyElements();
    }
    static getEntryName(): string {
        return "BackgroundLocationPage";
    }
}
registerNamedRoute(() => new BackgroundLocationPage(undefined, {}), "", { bundleName: "com.tencent.TencentLocationSDKDemo_HarmonyOS", moduleName: "entry", pagePath: "pages/BackgroundLocationPage", pageFullPath: "entry/src/main/ets/pages/BackgroundLocationPage", integratedHsp: "false" });
