if (!("finalizeConstruction" in ViewPU.prototype)) {
    Reflect.set(ViewPU.prototype, "finalizeConstruction", () => { });
}
interface DeviceOrientationPage_Params {
    message?: string;
    displayString?: string;
    locationManager?: TencentLocationManager;
}
import sensor from "@ohos:sensor";
import { TencentLocationManager } from "@package:pkg_modules/.ohpm/TencentLocationSDK@t7utmt6zbidmbd+rcrnd4pbf1yjg6gzq6rfynyunhja=/pkg_modules/TencentLocationSDK/Index";
class DeviceOrientationPage extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.__message = new ObservedPropertySimplePU('DeviceOrientationPage', this, "message");
        this.__displayString = new ObservedPropertySimplePU('', this, "displayString");
        this.locationManager = TencentLocationManager.getInstance();
        this.setInitiallyProvidedValue(params);
        this.finalizeConstruction();
    }
    setInitiallyProvidedValue(params: DeviceOrientationPage_Params) {
        if (params.message !== undefined) {
            this.message = params.message;
        }
        if (params.displayString !== undefined) {
            this.displayString = params.displayString;
        }
        if (params.locationManager !== undefined) {
            this.locationManager = params.locationManager;
        }
    }
    updateStateVars(params: DeviceOrientationPage_Params) {
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__message.purgeDependencyOnElmtId(rmElmtId);
        this.__displayString.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__message.aboutToBeDeleted();
        this.__displayString.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private __message: ObservedPropertySimplePU<string>;
    get message() {
        return this.__message.get();
    }
    set message(newValue: string) {
        this.__message.set(newValue);
    }
    private __displayString: ObservedPropertySimplePU<string>;
    get displayString() {
        return this.__displayString.get();
    }
    set displayString(newValue: string) {
        this.__displayString.set(newValue);
    }
    private locationManager?: TencentLocationManager;
    onPageShow(): void {
    }
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            RelativeContainer.create();
        }, RelativeContainer);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Column.create({ space: 30 });
            Column.height('100%');
            Column.width('100%');
        }, Column);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Text.create(this.message);
            Text.fontSize(50);
            Text.fontWeight(FontWeight.Bold);
        }, Text);
        Text.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            TextArea.create({ text: this.displayString });
            TextArea.fontSize(15);
            TextArea.margin({ top: 20, bottom: 20 });
            TextArea.height('50%');
            TextArea.width('100%');
            TextArea.align(Alignment.TopStart);
            TextArea.textAlign(TextAlign.Start);
            TextArea.enableKeyboardOnFocus(false);
        }, TextArea);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create({ space: 30 });
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel('device orientation');
            Button.onClick(() => {
                this.demoStartReceiveDeviceOrientation();
            });
        }, Button);
        Button.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel('stop');
            Button.onClick(() => {
                this.locationManager?.stopReceivingDeviceOrientation();
            });
        }, Button);
        Button.pop();
        Row.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create({ space: 30 });
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel('ROTATION VECTOR');
            Button.onClick(() => {
                this.systemStartReceiveDeviceOrientation();
            });
        }, Button);
        Button.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel('stop');
            Button.onClick(() => {
                sensor.off(sensor.SensorId.ROTATION_VECTOR);
            });
        }, Button);
        Button.pop();
        Row.pop();
        Column.pop();
        RelativeContainer.pop();
    }
    demoStartReceiveDeviceOrientation() {
        try {
            this.locationManager?.startReceivingDeviceOrientation(orientation => {
                console.log("mqdev", `device orientation: ${orientation}`);
                this.displayString = `${orientation} \n` + this.displayString;
            });
        }
        catch (error) {
            console.error("mqdev", `device orientation error: ${JSON.stringify(error)}}`);
        }
    }
    systemStartReceiveDeviceOrientation() {
        sensor.on(sensor.SensorId.ROTATION_VECTOR, async (rotationVectorData: sensor.RotationVectorResponse) => {
            try {
                console.log('mqdev', `system - ROTATION_VECTOR: ${JSON.stringify(rotationVectorData)}`);
                this.displayString = `ROTATION_VECTOR.x: ${rotationVectorData.x} \n` + this.displayString;
            }
            catch (error) {
            }
        });
    }
    rerender() {
        this.updateDirtyElements();
    }
    static getEntryName(): string {
        return "DeviceOrientationPage";
    }
}
registerNamedRoute(() => new DeviceOrientationPage(undefined, {}), "", { bundleName: "com.tencent.TencentLocationSDKDemo_HarmonyOS", moduleName: "entry", pagePath: "pages/DeviceOrientationPage", pageFullPath: "entry/src/main/ets/pages/DeviceOrientationPage", integratedHsp: "false" });
