if (!("finalizeConstruction" in ViewPU.prototype)) {
    Reflect.set(ViewPU.prototype, "finalizeConstruction", () => { });
}
interface GeofencePage_Params {
    message?: string;
    displayString?: string;
    locationManager?: TencentLocationManager;
    // 地理围栏
    currentLocationGeofenceID?: number;
    geofenceIDs?: Array<number>;
}
import { TencentLocationConstant, TencentLocationManager, TencentLocationRequest, TencentGeofenceRequest, TencentGeofence } from "@package:pkg_modules/.ohpm/TencentLocationSDK@t7utmt6zbidmbd+rcrnd4pbf1yjg6gzq6rfynyunhja=/pkg_modules/TencentLocationSDK/Index";
import type { TencentLocationError, TencentGeofenceEvent } from "@package:pkg_modules/.ohpm/TencentLocationSDK@t7utmt6zbidmbd+rcrnd4pbf1yjg6gzq6rfynyunhja=/pkg_modules/TencentLocationSDK/Index";
import notificationManager from "@ohos:notificationManager";
const TAG = '[GeofencePage]';
class GeofencePage extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.__message = new ObservedPropertySimplePU('地理围栏', this, "message");
        this.__displayString = new ObservedPropertySimplePU('', this, "displayString");
        this.locationManager = TencentLocationManager.getInstance();
        this.currentLocationGeofenceID = -1;
        this.geofenceIDs = new Array<number>();
        this.setInitiallyProvidedValue(params);
        this.finalizeConstruction();
    }
    setInitiallyProvidedValue(params: GeofencePage_Params) {
        if (params.message !== undefined) {
            this.message = params.message;
        }
        if (params.displayString !== undefined) {
            this.displayString = params.displayString;
        }
        if (params.locationManager !== undefined) {
            this.locationManager = params.locationManager;
        }
        if (params.currentLocationGeofenceID !== undefined) {
            this.currentLocationGeofenceID = params.currentLocationGeofenceID;
        }
        if (params.geofenceIDs !== undefined) {
            this.geofenceIDs = params.geofenceIDs;
        }
    }
    updateStateVars(params: GeofencePage_Params) {
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__message.purgeDependencyOnElmtId(rmElmtId);
        this.__displayString.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__message.aboutToBeDeleted();
        this.__displayString.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private __message: ObservedPropertySimplePU<string>;
    get message() {
        return this.__message.get();
    }
    set message(newValue: string) {
        this.__message.set(newValue);
    }
    private __displayString: ObservedPropertySimplePU<string>;
    get displayString() {
        return this.__displayString.get();
    }
    set displayString(newValue: string) {
        this.__displayString.set(newValue);
    }
    private locationManager?: TencentLocationManager;
    // 地理围栏
    private currentLocationGeofenceID: number;
    private geofenceIDs: Array<number>;
    onPageShow(): void {
    }
    aboutToAppear(): void {
        ;
    }
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            RelativeContainer.create();
        }, RelativeContainer);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Column.create({ space: 30 });
            Column.height('100%');
            Column.width('100%');
        }, Column);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Text.create(this.message);
            Text.fontSize(50);
            Text.fontWeight(FontWeight.Bold);
        }, Text);
        Text.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            TextArea.create({ text: this.displayString });
            TextArea.fontSize(15);
            TextArea.margin({ top: 20, bottom: 20 });
            TextArea.height('20%');
            TextArea.width('100%');
            TextArea.align(Alignment.TopStart);
            TextArea.textAlign(TextAlign.Start);
            TextArea.enableKeyboardOnFocus(false);
        }, TextArea);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create({ space: 30 });
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel('添加当前位置');
            Button.onClick(() => {
                this.addCurrentLocation();
            });
        }, Button);
        Button.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel('删除当前位置的围栏');
            Button.onClick(() => {
                this.removeCurrentLocation();
            });
        }, Button);
        Button.pop();
        Row.pop();
        Column.pop();
        RelativeContainer.pop();
    }
    addCurrentLocation() {
        const request = TencentLocationRequest.default().setRequestLevel(TencentLocationConstant.RequestLevel.GEO).setSingleLocationTimeout(3).setLocatingPriority(TencentLocationConstant.LocatingPriority.PRIORITY_ACCURACY);
        this.locationManager?.startSingleLocation(request, tencentLocation => {
            console.log(TAG, `单次定位成功`);
            this.displayString += `单次定位成功 (Source: GNSS = 1, NETWORK = 2, INDOOR = 3, RTK = 4): ${JSON.stringify(tencentLocation)}\n`;
            // 添加地理围栏
            const geofence: TencentGeofence = new TencentGeofence(tencentLocation.latitude!, tencentLocation.longitude!, 10, 60 * 60 * 24, TencentLocationConstant.CoordinateType.GCJ02);
            const callback = (error: TencentLocationError, geofenceEvent: TencentGeofenceEvent) => {
                if (error) {
                    console.error(TAG, `geofence event error: ${error.code},${error.name},${error.message}`);
                    return;
                }
                if (geofenceEvent.event == TencentLocationConstant.GeofenceEvent.ENTER) {
                    console.log(TAG, `enter geofence: ${JSON.stringify(geofenceEvent)}`);
                    this.displayString += `geofence event succeed - enter: ${JSON.stringify(geofenceEvent)}\n`;
                }
                else if (geofenceEvent.event == TencentLocationConstant.GeofenceEvent.EXIT) {
                    console.log(TAG, `exit geofence: ${JSON.stringify(geofenceEvent)}`);
                    this.displayString += `geofence event succeed - exit: ${JSON.stringify(geofenceEvent)}\n`;
                }
                else if (geofenceEvent.event == TencentLocationConstant.GeofenceEvent.DWELL) {
                    console.log(TAG, `dwell geofence: ${JSON.stringify(geofenceEvent)}`);
                    this.displayString += `geofence event succeed - dwell: ${JSON.stringify(geofenceEvent)}\n`;
                }
            };
            let notificationRequestForEnter: notificationManager.NotificationRequest = {
                id: 1,
                content: {
                    notificationContentType: notificationManager.ContentType.NOTIFICATION_CONTENT_BASIC_TEXT,
                    normal: {
                        title: "围栏通知",
                        text: "进入围栏",
                        additionalText: "event enter"
                    }
                }
            };
            let notificationRequestForExit: notificationManager.NotificationRequest = {
                id: 2,
                content: {
                    notificationContentType: notificationManager.ContentType.NOTIFICATION_CONTENT_BASIC_TEXT,
                    normal: {
                        title: "围栏通知",
                        text: "离开围栏",
                        additionalText: "event exit"
                    }
                }
            };
            let notificationRequestForDwell: notificationManager.NotificationRequest = {
                id: 3,
                content: {
                    notificationContentType: notificationManager.ContentType.NOTIFICATION_CONTENT_BASIC_TEXT,
                    normal: {
                        title: "围栏通知",
                        text: "在围栏中...",
                        additionalText: "event dwell"
                    }
                }
            };
            const geofenceRequest: TencentGeofenceRequest = new TencentGeofenceRequest(geofence, [TencentLocationConstant.GeofenceEvent.ENTER, TencentLocationConstant.GeofenceEvent.EXIT, TencentLocationConstant.GeofenceEvent.DWELL], callback, [notificationRequestForEnter, notificationRequestForExit, notificationRequestForDwell]);
            this.locationManager?.addGeofence(geofenceRequest).then(geofenceID => {
                this.displayString += `添加地理围栏成功, geofenceID: ${geofenceID}\n`;
                this.currentLocationGeofenceID = geofenceID;
            });
        }, error => {
            const errorString = `error: ${error.code},${error.name},${error.message}` + '\n----------\n';
            console.error(TAG, `单次定位失败, ${errorString}`);
        });
    }
    removeCurrentLocation() {
        try {
            this.locationManager?.removeGeofence(this.currentLocationGeofenceID);
            this.displayString += `remove geofence succeed: ${this.currentLocationGeofenceID}\n`;
            console.log(TAG, `remove geofence succeed`);
        }
        catch (error) {
            console.error(TAG, `remove geofence error: ${error}`);
        }
    }
    rerender() {
        this.updateDirtyElements();
    }
    static getEntryName(): string {
        return "GeofencePage";
    }
}
registerNamedRoute(() => new GeofencePage(undefined, {}), "", { bundleName: "com.tencent.TencentLocationSDKDemo_HarmonyOS", moduleName: "entry", pagePath: "pages/GeofencePage", pageFullPath: "entry/src/main/ets/pages/GeofencePage", integratedHsp: "false" });
