if (!("finalizeConstruction" in ViewPU.prototype)) {
    Reflect.set(ViewPU.prototype, "finalizeConstruction", () => { });
}
interface HomePage_Params {
    title?: string;
    context?: common.UIAbilityContext;
    homeList?: Array<string>;
}
import type common from "@ohos:app.ability.common";
import { CommonConstant } from "@bundle:com.tencent.TencentLocationSDKDemo_HarmonyOS/entry/ets/common/CommonConstants";
import HomeListItem from "@bundle:com.tencent.TencentLocationSDKDemo_HarmonyOS/entry/ets/views/HomeListItem";
import PermissionUtil from "@bundle:com.tencent.TencentLocationSDKDemo_HarmonyOS/entry/ets/common/PermissionUtil";
import router from "@ohos:router";
import process from "@ohos:process";
const TAG: string = '[HomePage]';
class HomePage extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.__title = new ObservedPropertySimplePU('TencentLocationSDKDemo', this, "title");
        this.context = getContext(this) as common.UIAbilityContext;
        this.homeList = [];
        this.setInitiallyProvidedValue(params);
        this.finalizeConstruction();
    }
    setInitiallyProvidedValue(params: HomePage_Params) {
        if (params.title !== undefined) {
            this.title = params.title;
        }
        if (params.context !== undefined) {
            this.context = params.context;
        }
        if (params.homeList !== undefined) {
            this.homeList = params.homeList;
        }
    }
    updateStateVars(params: HomePage_Params) {
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__title.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__title.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private __title: ObservedPropertySimplePU<string>;
    get title() {
        return this.__title.get();
    }
    set title(newValue: string) {
        this.__title.set(newValue);
    }
    private context: common.UIAbilityContext;
    private homeList: Array<string>;
    // 创建实例后触发一次，在执行其build函数之前执行
    aboutToAppear() {
        console.error(TAG, `主线程: [${process.tid}]`);
        // 权限检查
        PermissionUtil.checkPermissions(CommonConstant.REQUEST_PERMISSIONS).then((data) => {
            if (!data) {
                PermissionUtil.requestPermissions(CommonConstant.REQUEST_PERMISSIONS);
            }
        });
        // 首页列表数据
        this.homeList = [
            'Playground',
            '连续定位',
            '单次定位',
            '最后定位',
            '后台定位',
            '地理围栏',
            '辅助功能 - 设备朝向'
        ];
    }
    // 页面每次显示时触发一次，包括路由过程、应用进入前后台等场景，仅@Entry修饰的自定义组件生效
    onPageShow() {
    }
    // 当用户点击返回按钮时触发，仅@Entry修饰的自定义组件生效。
    onBackPress() {
    }
    // 页面每次隐藏时触发一次，包括路由过程、应用进入前后台等场景，仅@Entry修饰的自定义组件生效
    onPageHide() {
    }
    // 自定义组件析构销毁之前执行
    aboutToDisappear() {
    }
    // 页面跳转
    jumpToPage(page: string) {
        if (page === 'Playground') {
            router.pushUrl({ url: 'pages/PlaygroundPage', });
        }
        else if (page === '连续定位') {
            router.pushUrl({ url: 'pages/ContinuousLocationPage', });
        }
        else if (page === '单次定位') {
            router.pushUrl({ url: 'pages/SingleLocationPage', });
        }
        else if (page === '最后定位') {
            router.pushUrl({ url: 'pages/LastLocationPage', });
        }
        else if (page === '后台定位') {
            router.pushUrl({ url: 'pages/BackgroundLocationPage', });
        }
        else if (page === '地理围栏') {
            router.pushUrl({ url: 'pages/GeofencePage', });
        }
        else if (page === '辅助功能 - 设备朝向') {
            router.pushUrl({ url: 'pages/DeviceOrientationPage', });
        }
    }
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Column.create();
            Column.width('100%');
            Column.height('100%');
            Column.backgroundColor("#F1F3F5");
        }, Column);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Text.create(this.title);
            Text.fontSize(20);
            Text.fontWeight(FontWeight.Bold);
            Text.margin({ top: 20, bottom: 20 });
        }, Text);
        Text.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            ForEach.create();
            const forEachItemGenFunction = _item => {
                const item = _item;
                this.observeComponentCreation2((elmtId, isInitialRender) => {
                    __Common__.create();
                    __Common__.padding({ bottom: 20 });
                    __Common__.onClick(() => {
                        this.jumpToPage(item);
                    });
                }, __Common__);
                {
                    this.observeComponentCreation2((elmtId, isInitialRender) => {
                        if (isInitialRender) {
                            let componentCall = new HomeListItem(this, { content: item }, undefined, elmtId, () => { }, { page: "entry/src/main/ets/pages/HomePage.ets", line: 83, col: 9 });
                            ViewPU.create(componentCall);
                            let paramsLambda = () => {
                                return {
                                    content: item
                                };
                            };
                            componentCall.paramsGenerator_ = paramsLambda;
                        }
                        else {
                            this.updateStateVarsOfChildByElmtId(elmtId, {});
                        }
                    }, { name: "HomeListItem" });
                }
                __Common__.pop();
            };
            this.forEachUpdateFunction(elmtId, this.homeList, forEachItemGenFunction, (item: string) => JSON.stringify(item), false, false);
        }, ForEach);
        ForEach.pop();
        Column.pop();
    }
    rerender() {
        this.updateDirtyElements();
    }
    static getEntryName(): string {
        return "HomePage";
    }
}
registerNamedRoute(() => new HomePage(undefined, {}), "", { bundleName: "com.tencent.TencentLocationSDKDemo_HarmonyOS", moduleName: "entry", pagePath: "pages/HomePage", pageFullPath: "entry/src/main/ets/pages/HomePage", integratedHsp: "false" });
