if (!("finalizeConstruction" in ViewPU.prototype)) {
    Reflect.set(ViewPU.prototype, "finalizeConstruction", () => { });
}
interface SingleLocationPage_Params {
    message?: string;
    coordinateType?: TencentLocationConstant.CoordinateType;
    requestLevel?: TencentLocationConstant.RequestLevel;
    locationResultString?: string;
    locationManager?: TencentLocationManager;
    locationManager2?: TencentLocationManager;
}
import { TencentLocationConstant, TencentLocationManager, TencentLocationRequest } from "@package:pkg_modules/.ohpm/TencentLocationSDK@t7utmt6zbidmbd+rcrnd4pbf1yjg6gzq6rfynyunhja=/pkg_modules/TencentLocationSDK/Index";
import { displayStringForTencentLocation } from "@bundle:com.tencent.TencentLocationSDKDemo_HarmonyOS/entry/ets/utils/TencentUtils";
const TAG = '[SingleLocationPage]';
class SingleLocationPage extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.__message = new ObservedPropertySimplePU('单次定位', this, "message");
        this.__coordinateType = new ObservedPropertySimplePU(TencentLocationConstant.CoordinateType.GCJ02, this, "coordinateType");
        this.__requestLevel = new ObservedPropertySimplePU(TencentLocationConstant.RequestLevel.GEO, this, "requestLevel");
        this.__locationResultString = new ObservedPropertySimplePU('', this, "locationResultString");
        this.locationManager = TencentLocationManager.getInstance();
        this.locationManager2 = TencentLocationManager.getInstance();
        this.setInitiallyProvidedValue(params);
        this.finalizeConstruction();
    }
    setInitiallyProvidedValue(params: SingleLocationPage_Params) {
        if (params.message !== undefined) {
            this.message = params.message;
        }
        if (params.coordinateType !== undefined) {
            this.coordinateType = params.coordinateType;
        }
        if (params.requestLevel !== undefined) {
            this.requestLevel = params.requestLevel;
        }
        if (params.locationResultString !== undefined) {
            this.locationResultString = params.locationResultString;
        }
        if (params.locationManager !== undefined) {
            this.locationManager = params.locationManager;
        }
        if (params.locationManager2 !== undefined) {
            this.locationManager2 = params.locationManager2;
        }
    }
    updateStateVars(params: SingleLocationPage_Params) {
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__message.purgeDependencyOnElmtId(rmElmtId);
        this.__coordinateType.purgeDependencyOnElmtId(rmElmtId);
        this.__requestLevel.purgeDependencyOnElmtId(rmElmtId);
        this.__locationResultString.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__message.aboutToBeDeleted();
        this.__coordinateType.aboutToBeDeleted();
        this.__requestLevel.aboutToBeDeleted();
        this.__locationResultString.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private __message: ObservedPropertySimplePU<string>;
    get message() {
        return this.__message.get();
    }
    set message(newValue: string) {
        this.__message.set(newValue);
    }
    // 配置
    private __coordinateType: ObservedPropertySimplePU<TencentLocationConstant.CoordinateType>;
    get coordinateType() {
        return this.__coordinateType.get();
    }
    set coordinateType(newValue: TencentLocationConstant.CoordinateType) {
        this.__coordinateType.set(newValue);
    }
    private __requestLevel: ObservedPropertySimplePU<TencentLocationConstant.RequestLevel>;
    get requestLevel() {
        return this.__requestLevel.get();
    }
    set requestLevel(newValue: TencentLocationConstant.RequestLevel) {
        this.__requestLevel.set(newValue);
    }
    private __locationResultString: ObservedPropertySimplePU<string>;
    get locationResultString() {
        return this.__locationResultString.get();
    }
    set locationResultString(newValue: string) {
        this.__locationResultString.set(newValue);
    }
    private locationManager?: TencentLocationManager;
    private locationManager2?: TencentLocationManager;
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            RelativeContainer.create();
            RelativeContainer.height('100%');
            RelativeContainer.width('100%');
        }, RelativeContainer);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Column.create({ space: 30 });
        }, Column);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Text.create(this.message);
            Text.fontSize(50);
            Text.fontWeight(FontWeight.Bold);
        }, Text);
        Text.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            TextArea.create({ text: this.locationResultString });
            TextArea.fontSize(15);
            TextArea.margin({ top: 20, bottom: 20 });
            TextArea.height('50%');
            TextArea.width('100%');
            TextArea.align(Alignment.TopStart);
            TextArea.textAlign(TextAlign.Start);
        }, TextArea);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create({ space: 30 });
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel(this.coordinateType === TencentLocationConstant.CoordinateType.GCJ02 ? '当前坐标类型: GCJ02' : '当前坐标类型: WGS84');
            Button.onClick(() => {
                if (this.coordinateType === TencentLocationConstant.CoordinateType.GCJ02) {
                    this.coordinateType = TencentLocationConstant.CoordinateType.WGS84;
                }
                else {
                    this.coordinateType = TencentLocationConstant.CoordinateType.GCJ02;
                }
            });
        }, Button);
        Button.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel(this.requestLevel === TencentLocationConstant.RequestLevel.GEO ? '当前 LEVEL: GEO' : '当前 LEVEL: POI');
            Button.onClick(() => {
                if (this.requestLevel === TencentLocationConstant.RequestLevel.GEO) {
                    this.requestLevel = TencentLocationConstant.RequestLevel.POI;
                }
                else {
                    this.requestLevel = TencentLocationConstant.RequestLevel.GEO;
                }
            });
        }, Button);
        Button.pop();
        Row.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create({ space: 30 });
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel('单次定位');
            Button.onClick(() => {
                const request = TencentLocationRequest.default();
                request
                    .setCoordinateType(this.coordinateType)
                    .setRequestLevel(this.requestLevel);
                this.locationWithRequest(request);
            });
        }, Button);
        Button.pop();
        Row.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create({ space: 30 });
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel('clear');
            Button.onClick(() => {
                this.locationResultString = '';
            });
        }, Button);
        Button.pop();
        Row.pop();
        Column.pop();
        RelativeContainer.pop();
    }
    locationWithRequest(request: TencentLocationRequest, request_02: TencentLocationRequest | undefined = undefined) {
        this.locationManager?.startSingleLocation(request, tencentLocation => {
            const displayString = `request: ${request.displayStringFroSingleLocation()}, ` + `tencentLocation: ${displayStringForTencentLocation(tencentLocation)}` + '\n----------\n';
            this.locationResultString += displayString;
            console.log(TAG, `单次定位成功, ${displayString}`);
        }, error => {
            const errorString = `error: ${error.code},${error.name},${error.message}` + '\n----------\n';
            this.locationResultString += errorString;
            console.error(TAG, `单次定位失败, ${errorString}`);
        });
        if (request_02) {
            this.locationManager2?.startSingleLocation(request_02, tencentLocation => {
                const displayString = `request_02: ${request_02.displayStringFroSingleLocation()}, ` + `tencentLocation: ${displayStringForTencentLocation(tencentLocation)}` + '\n----------\n';
                this.locationResultString += displayString;
                console.log(TAG, `单次定位成功_02, ${displayString}`);
            }, error => {
                const errorString = `error: ${error.code},${error.name},${error.message}` + '\n----------\n';
                this.locationResultString += errorString;
                console.error(TAG, `单次定位失败_02, ${errorString}`);
            });
        }
    }
    rerender() {
        this.updateDirtyElements();
    }
    static getEntryName(): string {
        return "SingleLocationPage";
    }
}
registerNamedRoute(() => new SingleLocationPage(undefined, {}), "", { bundleName: "com.tencent.TencentLocationSDKDemo_HarmonyOS", moduleName: "entry", pagePath: "pages/SingleLocationPage", pageFullPath: "entry/src/main/ets/pages/SingleLocationPage", integratedHsp: "false" });
