import { TencentLocationConstant } from "@package:pkg_modules/.ohpm/TencentLocationSDK@t7utmt6zbidmbd+rcrnd4pbf1yjg6gzq6rfynyunhja=/pkg_modules/TencentLocationSDK/Index";
import type { TencentLocation } from "@package:pkg_modules/.ohpm/TencentLocationSDK@t7utmt6zbidmbd+rcrnd4pbf1yjg6gzq6rfynyunhja=/pkg_modules/TencentLocationSDK/Index";
export function displayStringForTencentLocation(location: TencentLocation) {
    return `{(${location.latitude},${location.longitude}),` +
        `${displayStringForLocationSource(location.source!)},` +
        `${new Date(location.timeStamp!).toLocaleString()},` +
        `${JSON.stringify(location.geoAddress)},` +
        `${JSON.stringify(location.poiList)}}`;
}
function displayStringForLocationSource(locationSource: TencentLocationConstant.LocationSource) {
    switch (locationSource) {
        case TencentLocationConstant.LocationSource.GNSS:
            return 'GNSS';
        case TencentLocationConstant.LocationSource.NETWORK:
            return 'NETWORK';
        case TencentLocationConstant.LocationSource.INDOOR:
            return 'INDOOR';
        case TencentLocationConstant.LocationSource.RTK:
            return 'RTK';
        default:
            return 'WRONG_VALUE';
    }
}
export function displayStringForTime(timeStamp: number | undefined): string {
    if (!timeStamp) {
        return '';
    }
    return new Date(timeStamp).toLocaleString();
}
export function displayStringForShortTime(timeStamp: number | undefined): string {
    if (!timeStamp) {
        return '';
    }
    return new Date(timeStamp).toTimeString();
}
