import fs from '@ohos:file.fs'; import w1 from "@package:pkg_modules/.ohpm/TencentLocationSDK@cb2yd0275sgkkwdrgypqigkv5q+yocybwqjl0bqzscw=/pkg_modules/TencentLocationSDK/src/main/ets/locationsdk/utils/j"; import buffer from "@ohos:buffer"; import worker from "@ohos:worker"; import { TxStringUtil } from "@package:pkg_modules/.ohpm/TencentLocationSDK@cb2yd0275sgkkwdrgypqigkv5q+yocybwqjl0bqzscw=/pkg_modules/TencentLocationSDK/src/main/ets/locationsdk/utils/s"; import { TxCompressType, TxEncryptionType } from "@package:pkg_modules/.ohpm/TencentLocationSDK@cb2yd0275sgkkwdrgypqigkv5q+yocybwqjl0bqzscw=/pkg_modules/TencentLocationSDK/src/main/ets/locationsdk/utils/a1"; import { TxCompressUtil } from "@package:pkg_modules/.ohpm/TencentLocationSDK@cb2yd0275sgkkwdrgypqigkv5q+yocybwqjl0bqzscw=/pkg_modules/TencentLocationSDK/src/main/ets/locationsdk/utils/b1"; import { TxEncryptionUtil } from "@package:pkg_modules/.ohpm/TencentLocationSDK@cb2yd0275sgkkwdrgypqigkv5q+yocybwqjl0bqzscw=/pkg_modules/TencentLocationSDK/src/main/ets/locationsdk/utils/c1"; import { TxFileUtil } from "@package:pkg_modules/.ohpm/TencentLocationSDK@cb2yd0275sgkkwdrgypqigkv5q+yocybwqjl0bqzscw=/pkg_modules/TencentLocationSDK/src/main/ets/locationsdk/utils/v/z"; import { TxDataUtil } from "@package:pkg_modules/.ohpm/TencentLocationSDK@cb2yd0275sgkkwdrgypqigkv5q+yocybwqjl0bqzscw=/pkg_modules/TencentLocationSDK/src/main/ets/locationsdk/utils/d1"; const z1 = '[TxFileWriter]'; export class TxFileWriter { constructor(k8, l8 = true, m8 = TxFileWriter.defaultFileStrategy) { this.fileStrategy = TxFileWriter.defaultFileStrategy; this.fileWriterWorker = new worker.ThreadWorker('../workers/TxFileWriterWorker.ets'); this.destinationPath = k8; this.fileStrategy = m8; this.useWorker = l8; this.writeBuffer = buffer.alloc(this.fileStrategy.bufferSize); this.realBufferSize = 0; try { this.destinationFile = fs.openSync(this.destinationPath, fs.OpenMode.READ_WRITE | fs.OpenMode.CREATE | fs.OpenMode.APPEND); } catch (error) { w1.info(z1, `open file failed: ${error}`); } } async write(content) { if (this.useWorker) { try { this.fileWriterWorker.postMessage({ filePath: this.destinationPath, content: content, }); } catch (error) { w1.error(z1, `file writer worker post message failed: ${error.message}}`); } } else { await this._write(content); } } async _write(content) { if (!this.destinationFile) { try { this.destinationFile = fs.openSync(this.destinationPath, fs.OpenMode.READ_WRITE | fs.OpenMode.CREATE | fs.OpenMode.APPEND); w1.info(z1, `recreate file: ${this.destinationPath}`); } catch (error) { w1.info(z1, `reopen file failed: ${error}`); } } if (!this.destinationFile) { return; } let j8; if (typeof content === 'string') { j8 = TxStringUtil.stringToUint8Array(content); } else { j8 = content; } w1.error(z1, `content is now Uint8Array, string: ${TxStringUtil.stringFromUint8Array(j8)}`); if (this.realBufferSize + j8.length <= this.fileStrategy.bufferSize) { w1.info(z1, 'buffer left is enough, write to buffer'); this.writeUint8ArrayToBuffer(j8); this.checkCurrentBufferSize(); } else { if (j8.length <= this.fileStrategy.bufferSize) { w1.info(z1, 'buffer left is not enough, empty it, and entire buffer is enough, write to empty buffer'); await this.flush(this.writeBuffer.buffer); this.writeUint8ArrayToBuffer(j8); this.checkCurrentBufferSize(); } else { w1.info(z1, 'entire buffer is not enough, empty buffer to keep the order, then write to file directly'); if (this.realBufferSize > 0) { await this.flush(this.writeBuffer.buffer); } await this.flush(j8.buffer, j8.length); } } } async flush(data, length = this.realBufferSize) { w1.info(z1, `flush - buffer that wirte to file: ${TxStringUtil.stringFromUint8Array(data)}, data size: ${length}`); try { let d8 = data; let e8 = length; const f8 = TxFileUtil.getParent(this.destinationFile); if (this.fileStrategy.encryptionType === TxEncryptionType.XOR) { d8 = TxEncryptionUtil.xor(d8); } const g8 = fs.writeSync(this.destinationFile?.fd, d8, { length: e8 }); this.realBufferSize = 0; w1.info(z1, `write data to file succeed and size is: ${g8}`); const h8 = TxFileUtil.getFileSize(this.destinationPath); if (h8 > this.fileStrategy.storageStrategy.singleFileMaxSize) { if (this.fileStrategy.compressType === TxCompressType.ZLIB) { let i8 = ''; if (this.fileStrategy.renameStrategy.dynamicPart === 'date') { i8 = f8 + '/' + this.fileStrategy.renameStrategy.fixPart + TxDataUtil.getCurTimeStr(this.fileStrategy.renameStrategy.dateFormatString); } else if (this.fileStrategy.renameStrategy.dynamicPart === 'sequence') { } w1.warn(z1, `start compress, file size: ${h8}}`); await TxCompressUtil.compressFileWithZlib(this.destinationPath, i8, undefined, true); this.destinationFile = undefined; w1.warn(z1, `compress done, file size: ${TxFileUtil.getFileSize(i8)}}`); } else if (this.fileStrategy.compressType === TxCompressType.GZIP) { } if (this.fileStrategy.storageStrategy.totalFileMaxSize != -1) { TxFileUtil.checkDirectorySizeAndClean(f8, this.fileStrategy.storageStrategy.totalFileMaxSize, this.fileStrategy.storageStrategy.cleanFilesCount); } } } catch (err) { w1.error(z1, `write data to file failed with error message: ${err.message}, error code: ${err.code}`); } } writeUint8ArrayToBuffer(data) { w1.info(z1, `string writes to buffer: ${TxStringUtil.stringFromUint8Array(data)}`); for (let index = 0; index < data.byteLength; index++) { try { const c8 = data[index]; this.realBufferSize = this.writeBuffer.writeUInt8(c8, this.realBufferSize); } catch (error) { } } } checkCurrentBufferSize() { if (this.realBufferSize === this.fileStrategy.bufferSize) { w1.info(z1, '缓存刚好满了, 写入文件'); this.flush(this.writeBuffer.buffer); this.realBufferSize = 0; } } } TxFileWriter.defaultFileStrategy = { bufferSize: 8 * 1024, encryptionType: TxEncryptionType.XOR, compressType: TxCompressType.ZLIB, storageStrategy: { singleFileMaxSize: 10 * 1024 * 1024, totalFileMaxSize: 50 * 1024 * 1024, cleanFilesCount: 2 }, renameStrategy: { fixPart: 'txfile_', dynamicPart: 'date', dateFormatString: 'yyyyMMdd_HHmmss.SSS' }, }; 