import { TencentLocationConstant } from "./a"; import w1 from "./utils/j"; const z1 = "[TencentLocationRequest]"; export class TencentLocationRequest { constructor(p6, q6, r6, s6, t6, interval, u6, v6, locatingPriority, w6) { this.coordinateType = p6; this.requestLevel = q6; this.enableBackgroundLocation = r6; this.userActivityScenario = s6; this.powerConsumptionScenario = t6; this.interval = interval; this.innerInterval = u6; this.reverseGeocodeRequestInterval = v6; this.locatingPriority = locatingPriority; this.singleLocationTimeout = w6; } static default() { return new TencentLocationRequest(TencentLocationConstant.CoordinateType.GCJ02, TencentLocationConstant.RequestLevel.ADMIN_AREA, false, undefined, TencentLocationConstant.PowerConsumptionScenario.HIGH_POWER_CONSUMPTION, 1, 1, 10, TencentLocationConstant.LocatingPriority.PRIORITY_LOCATING_SPEED, 5); } setCoordinateType(o6) { this.coordinateType = o6; return this; } getCoordinateType() { return this.coordinateType; } setRequestLevel(n6) { this.requestLevel = n6; return this; } getRequestLevel() { return this.requestLevel; } setEnableBackgroundLocation(m6) { this.enableBackgroundLocation = m6; return this; } getEnableBackgroundLocation() { return this.enableBackgroundLocation; } setUserActivityScenario(l6) { this.userActivityScenario = l6; this.powerConsumptionScenario = undefined; return this; } getUserActivityScenario() { return this.userActivityScenario; } setPowerConsumptionScenario(k6) { this.powerConsumptionScenario = k6; this.userActivityScenario = undefined; return this; } getPowerConsumptionScenario() { return this.powerConsumptionScenario; } setInterval(interval) { if (interval === 0) { this.innerInterval = 0; } this.interval = interval < 0 ? 1 : interval; return this; } getInterval() { return this.interval; } setInnerInterval(j6) { if (j6 === 0) { this.interval = 0; } this.innerInterval = j6 < 0 ? 1 : j6; return this; } getInnerInterval() { return this.innerInterval; } setReverseGeocodeRequestInterval(i6) { if (i6 < 1) { i6 = 1; } this.reverseGeocodeRequestInterval = i6; return this; } getReverseGeocodeRequestInterval() { return this.reverseGeocodeRequestInterval; } setLocatingPriority(locatingPriority) { this.locatingPriority = locatingPriority; return this; } getLocatingPriority() { return this.locatingPriority; } setSingleLocationTimeout(h6) { if (h6 < 1) { h6 = 1; } this.singleLocationTimeout = h6; return this; } getSingleLocationTimeout() { return this.singleLocationTimeout; } toSystemContinuousLocationRequest() { let g6; if (this.userActivityScenario) { g6 = { interval: this.innerInterval, locationScenario: this.userActivityScenario }; } else { g6 = { interval: this.innerInterval, locationScenario: this.powerConsumptionScenario }; } w1.info(z1, `continuous location - request(system): ${this.displayStringForContinuousLocation()}`); return g6; } toSystemSingleLocationRequest() { const f6 = { locatingPriority: this.getLocatingPriority(), locatingTimeoutMs: this.singleLocationTimeout * 1000 }; w1.info(z1, `single location - request(system): ${this.displayStringFroSingleLocation()}`); return f6; } displayStringForCoordinateType() { switch (this.coordinateType) { case TencentLocationConstant.CoordinateType.WGS84: return 'WGS84'; case TencentLocationConstant.CoordinateType.GCJ02: return 'GCJ02'; default: return 'UNKNOWN'; } } displayStringForRequestLevel() { switch (this.requestLevel) { case TencentLocationConstant.RequestLevel.GEO: return 'GEO'; case TencentLocationConstant.RequestLevel.NAME: return 'NAME'; case TencentLocationConstant.RequestLevel.ADMIN_AREA: return 'ADMIN_AREA'; case TencentLocationConstant.RequestLevel.POI: return 'POI'; default: return 'UNKNOWN'; } } displayStringForUserActivityScenario() { switch (this.userActivityScenario) { case TencentLocationConstant.UserActivityScenario.NAVIGATION: return `NAVIGATION(${this.userActivityScenario})`; case TencentLocationConstant.UserActivityScenario.SPORT: return `SPORT(${this.userActivityScenario})`; case TencentLocationConstant.UserActivityScenario.TRANSPORT: return `TRANSPORT(${this.userActivityScenario})`; case TencentLocationConstant.UserActivityScenario.DAILY_LIFE_SERVICE: return `DAILY_LIFE_SERVICE(${this.userActivityScenario})`; default: return 'UNKNOWN'; } } displayStringForPowerConsumptionScenario() { switch (this.powerConsumptionScenario) { case TencentLocationConstant.PowerConsumptionScenario.HIGH_POWER_CONSUMPTION: return `HIGH_POWER_CONSUMPTION(${this.powerConsumptionScenario})`; case TencentLocationConstant.PowerConsumptionScenario.LOW_POWER_CONSUMPTION: return `LOW_POWER_CONSUMPTION(${this.powerConsumptionScenario})`; case TencentLocationConstant.PowerConsumptionScenario.NO_POWER_CONSUMPTION: return `NO_POWER_CONSUMPTION(${this.powerConsumptionScenario})`; default: return 'UNKNOWN'; } } displayStringForLocatingPriority() { switch (this.locatingPriority) { case TencentLocationConstant.LocatingPriority.PRIORITY_ACCURACY: return `PRIORITY_ACCURACY(${this.locatingPriority})`; case TencentLocationConstant.LocatingPriority.PRIORITY_LOCATING_SPEED: return `PRIORITY_LOCATING_SPEED(${this.locatingPriority})`; default: return 'UNKNOWN'; } } displayStringFroSingleLocation() { return `{${this.displayStringForCoordinateType()},${this.displayStringForRequestLevel()},` + `${this.displayStringForLocatingPriority()},` + `timeout:${this.singleLocationTimeout}s}`; } displayStringForContinuousLocation() { let e6 = ''; if (this.userActivityScenario === undefined) { e6 = this.displayStringForPowerConsumptionScenario(); } else { e6 = this.displayStringForUserActivityScenario(); } return `{${this.displayStringForCoordinateType()},${this.displayStringForRequestLevel()},` + e6 + ',' + `${this.innerInterval}-${this.interval}}`; } toString() { return `{"coordinateType":${this.displayStringForCoordinateType()},` + `"requestLevel":${this.displayStringForRequestLevel()},` + `"userActivityScenario":${this.displayStringForUserActivityScenario()},` + `"powerConsumptionScenario":${this.displayStringForPowerConsumptionScenario()},` + `"interval":${this.interval},` + `"innerInterval":${this.innerInterval},` + `"reverseGeocodeRequestInterval":${this.reverseGeocodeRequestInterval},` + `"locatingPriority":${this.displayStringForLocatingPriority()},` + `"singleLocationTimeout":${this.singleLocationTimeout}}`; } } 